[lib/ChangeLog]
[platform/upstream/coreutils.git] / Makefile.maint
1 # -*-Makefile-*-
2 # This Makefile fragment is shared between the coreutils,
3 # CPPI, Bison, and Autoconf.
4
5 ## Copyright (C) 2001-2007 Free Software Foundation, Inc.
6 ##
7 ## This program is free software; you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation; either version 2, or (at your option)
10 ## any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program; if not, write to the Free Software
19 ## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
20 ## 02110-1301, USA.
21
22 # This is reported not to work with make-3.79.1
23 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
24 ME := Makefile.maint
25
26 # Do not save the original name or timestamp in the .tar.gz file.
27 # Use --rsyncable if available.
28 gzip_rsyncable := \
29   $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null && echo --rsyncable)
30 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
31
32 CVS = cvs
33 GIT = git
34 VC = $(GIT)
35 VC-tag = git-tag -s -m '$(VERSION)'
36
37 CVS_LIST = build-aux/vc-list-files
38
39 CVS_LIST_EXCEPT = \
40   $(CVS_LIST) | if test -f .x-$@; then grep -vEf .x-$@; else grep -v ChangeLog; fi
41
42 ifeq ($(origin prev_version_file), undefined)
43   prev_version_file = .prev-version
44 endif
45
46 PREV_VERSION := $(shell cat $(prev_version_file))
47 VERSION_REGEXP = $(subst .,\.,$(VERSION))
48
49 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
50 tag-this-version = $(subst .,_,$(VERSION))
51 this-vc-tag = $(tag-package)-$(tag-this-version)
52 my_distdir = $(PACKAGE)-$(VERSION)
53
54 # Old releases are stored here.
55 # Used for diffs and xdeltas.
56 release_archive_dir ?= ../release
57
58 # Prevent programs like 'sort' from considering distinct strings to be equal.
59 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
60 export LC_ALL = C
61
62
63
64 ## --------------- ##
65 ## Sanity checks.  ##
66 ## --------------- ##
67
68 # FIXME: add a check to prohibit definition in src/*.c of symbols defined
69 # in system.h.  E.g. today I removed from tail.c a useless definition of
70 # ENOSYS.  It was useless because system.h ensures it's defined.
71
72 # Checks that don't require cvs.
73 # Run `changelog-check' last, as previous test may reveal problems requiring
74 # new ChangeLog entries.
75 local-checks-available = \
76   po-check copyright-check writable-files m4-check author_mark_check \
77   changelog-check patch-check strftime-check $(syntax-check-rules) \
78   makefile_path_separator_check \
79   makefile-check check-AUTHORS
80 .PHONY: $(local-checks-available)
81
82 local-check = $(filter-out $(local-checks-to-skip), $(local-checks-available))
83
84 # Collect the names of rules starting with `sc_'.
85 syntax-check-rules := $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' $(ME))
86 .PHONY: $(syntax-check-rules)
87
88 syntax-check: $(syntax-check-rules)
89 #       @grep -nE '#  *include <(limits|std(def|arg|bool))\.h>'         \
90 #           $$(find -type f -name '*.[chly]') &&                        \
91 #         { echo '$(ME): found conditional include' 1>&2;               \
92 #           exit 1; } || :
93
94 #       grep -nE '^#  *include <(string|stdlib)\.h>'                    \
95 #           $(srcdir)/{lib,src}/*.[chy] &&                              \
96 #         { echo '$(ME): FIXME' 1>&2;                                   \
97 #           exit 1; } || :
98 # FIXME: don't allow `#include .strings\.h' anywhere
99
100 sc_cast_of_argument_to_free:
101         @grep -nE '\<free \(\(' $(srcdir)/{lib,src}/*.[chly] &&         \
102           { echo '$(ME): don'\''t cast free argument' 1>&2;             \
103             exit 1; } || :
104
105 sc_cast_of_x_alloc_return_value:
106         @grep -nE --exclude=$(srcdir)/lib/xalloc.h                      \
107                 --exclude=$(srcdir)/lib/regex.c                         \
108             '\*\) *x(m|c|re)alloc\>'                                    \
109             $(srcdir)/{lib,src}/*.[chy] &&                              \
110           { echo '$(ME): don'\''t cast x*alloc return value' 1>&2;      \
111             exit 1; } || :
112
113 sc_cast_of_alloca_return_value:
114         @grep -nE '\*\) *alloca\>'                                      \
115             $(srcdir)/src/*.[chy] &&                                    \
116           { echo '$(ME): don'\''t cast alloca return value' 1>&2;       \
117             exit 1; } || :
118
119 sc_space_tab:
120         @grep -n '[ ]   ' $$($(CVS_LIST_EXCEPT)) &&                     \
121           { echo '$(ME): found SPACE-TAB sequence; remove the SPACE'    \
122                 1>&2; exit 1; } || :
123
124 # Don't use the old ato* functions in `real' code.
125 # They provide no error checking mechanism.
126 # Instead, use strto* functions.
127 sc_prohibit_atoi_atof:
128         @grep -nE '\<ato([filq]|ll)\>' $$($(CVS_LIST_EXCEPT)) &&        \
129           { echo '$(ME): do not use ato''f, ato''i, ato''l, ato''ll, or ato''q' \
130                 1>&2; exit 1; } || :
131
132 # Using EXIT_SUCCESS as the first argument to error is misleading,
133 # since when that parameter is 0, error does not exit.  Use `0' instead.
134 sc_error_exit_success:
135         @grep -nF 'error (EXIT_SUCCESS,'                                        \
136             $$(find -type f -name '*.[chly]') &&                        \
137           { echo '$(ME): found error (EXIT_SUCCESS' 1>&2;               \
138             exit 1; } || :
139
140 sc_file_system:
141         @grep -ni 'file''system' $$($(CVS_LIST_EXCEPT)) &&              \
142           { echo '$(ME): found use of "file''system";'                  \
143             'rewrite to use "file system"' 1>&2;                        \
144             exit 1; } || :
145
146 sc_no_have_config_h:
147         @grep -n 'HAVE''_CONFIG_H' $$($(CVS_LIST_EXCEPT)) &&            \
148           { echo '$(ME): found use of HAVE''_CONFIG_H; remove'          \
149                 1>&2; exit 1; } || :
150
151 # Nearly all .c files must include <config.h>.
152 sc_require_config_h:
153         @if $(CVS_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then         \
154           grep -L '^# *include <config\.h>'                             \
155                 $$($(CVS_LIST_EXCEPT) | grep '\.c$$')                   \
156               | grep . &&                                               \
157           { echo '$(ME): the above files do not include <config.h>'     \
158                 1>&2; exit 1; } || :;                                   \
159         else :;                                                         \
160         fi
161
162 # Prohibit the inclusion of assert.h without an actual use of assert.
163 sc_prohibit_assert_without_use:
164         @if $(CVS_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then         \
165           files=$$(grep -l '# *include <assert\.h>'                     \
166                     $$($(CVS_LIST_EXCEPT) | grep '\.c$$')) &&           \
167           grep -L '\<assert (' $$files                                  \
168               | grep . &&                                               \
169             { echo "$(ME): the above files include <assert.h> but don't use it" \
170                   1>&2; exit 1; } || :;                                 \
171         else :;                                                         \
172         fi
173
174 sc_obsolete_symbols:
175         @grep -nE '\<(HAVE''_FCNTL_H|O''_NDELAY)\>'                     \
176              $$($(CVS_LIST_EXCEPT)) &&                                  \
177           { echo '$(ME): do not use HAVE''_FCNTL_H or O''_NDELAY'       \
178                 1>&2; exit 1; } || :
179
180 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
181
182 # Each nonempty line must start with a year number, or a TAB.
183 sc_changelog:
184         @grep -n '^[^12 ]' $$(find . -maxdepth 2 -name ChangeLog) &&    \
185           { echo '$(ME): found unexpected prefix in a ChangeLog' 1>&2;  \
186             exit 1; } || :
187
188 # Ensure that dd's definition of LONGEST_SYMBOL stays in sync
189 # with the strings from the two affected variables.
190 dd_c = $(srcdir)/src/dd.c
191 sc_dd_max_sym_length:
192 ifneq ($(wildcard $(dd_c)),)
193         @len=$$( (sed -n '/conversions\[\] =$$/,/^};/p' $(dd_c);\
194                  sed -n '/flags\[\] =$$/,/^};/p' $(dd_c) )      \
195                 |sed -n '/"/s/^[^"]*"\([^"]*\)".*/\1/p'         \
196               | wc --max-line-length);                          \
197         max=$$(sed -n '/^#define LONGEST_SYMBOL /s///p' $(dd_c) \
198               |tr -d '"' | wc --max-line-length);               \
199         if test "$$len" = "$$max"; then :; else                 \
200           echo 'dd.c: LONGEST_SYMBOL is not longest' 1>&2;      \
201           exit 1;                                               \
202         fi
203 endif
204
205 # Many m4 macros names once began with `jm_'.
206 # On 2004-04-13, they were all changed to start with gl_ instead.
207 # Make sure that none are inadvertently reintroduced.
208 sc_prohibit_jm_in_m4:
209         @grep -nE 'jm_[A-Z]'                                    \
210                 $$($(CVS_LIST) m4 |grep '\.m4$$'; echo /dev/null) && \
211             { echo '$(ME): do not use jm_ in m4 macro names'    \
212               1>&2; exit 1; } || :
213
214 sc_root_tests:
215         @t1=sc-root.expected; t2=sc-root.actual;                        \
216         grep -nl '^PRIV_CHECK_ARG=require-root'                         \
217           $$($(CVS_LIST) tests) |sed s,tests,., |sort > $$t1;           \
218         sed -n 's,      cd \([^ ]*\) .*MAKE..check TESTS=\(.*\),./\1/\2,p' \
219           $(srcdir)/tests/Makefile.am |sort > $$t2;                     \
220         diff -u $$t1 $$t2 || diff=1;                                    \
221         rm -f $$t1 $$t2;                                                \
222         test "$$diff"                                                   \
223           && { echo 'tests/Makefile.am: missing check-root action'>&2;  \
224                exit 1; } || :
225
226 headers_with_interesting_macro_defs = \
227   exit.h        \
228   fcntl_.h      \
229   fnmatch_.h    \
230   intprops.h    \
231   inttypes_.h   \
232   lchown.h      \
233   openat.h      \
234   stat-macros.h \
235   stdint_.h
236
237 # Create a list of regular expressions matching the names
238 # of macros that are guaranteed by parts of gnulib to be defined.
239 .re-defmac:
240         @(cd $(srcdir)/lib;                                             \
241           for f in $(headers_with_interesting_macro_defs); do           \
242             test -f $$f &&                                              \
243               sed -n '/^# *define \([^_ (][^ (]*\)[ (].*/s//\1/p' $$f;  \
244            done;                                                        \
245          ) | sort -u                                                    \
246            | grep -Ev 'ATTRIBUTE_NORETURN|SIZE_MAX'                     \
247            | sed 's/^/^# *define /'                                     \
248           > $@-t
249         @mv $@-t $@
250
251 # Don't define macros that we already get from gnulib header files.
252 sc_always_defined_macros: .re-defmac
253         @if test -f $(srcdir)/src/system.h; then                        \
254           trap 'rc=$$?; rm -f .re-defmac; exit $$rc' 0 1 2 3 15;        \
255           grep -f .re-defmac $$($(CVS_LIST))                            \
256             && { echo '$(ME): define the above via some gnulib .h file' \
257                   1>&2;  exit 1; } || :;                                \
258         fi
259
260 # Create a list of regular expressions matching the names
261 # of files included from system.h.  Exclude a couple.
262 .re-list:
263         @sed -n '/^# *include /s///p' $(srcdir)/src/system.h \
264           | grep -Ev 'sys/(param|file)\.h' \
265           | sed 's/ .*//;;s/^["<]/^# *include [<"]/;s/\.h[">]$$/\\.h[">]/' \
266           > $@-t
267         @mv $@-t $@
268
269 # Files in src/ should not include directly any of
270 # the headers already included via system.h.
271 sc_system_h_headers: .re-list
272         @if test -f $(srcdir)/src/system.h; then                        \
273           trap 'rc=$$?; rm -f .re-list; exit $$rc' 0 1 2 3 15;          \
274           grep -nE -f .re-list                                          \
275               $$($(CVS_LIST) src |                                      \
276                  grep -Ev '((copy|system)\.h|parse-gram\.c)$$')         \
277             && { echo '$(ME): the above are already included via system.h'\
278                   1>&2;  exit 1; } || :;                                \
279         fi
280
281 sc_sun_os_names:
282         @grep -nEi \
283             'solaris[^[:alnum:]]*2\.(7|8|9|[1-9][0-9])|sunos[^[:alnum:]][6-9]' \
284             $$($(CVS_LIST_EXCEPT)) &&                                   \
285           { echo '$(ME): found misuse of Sun OS version numbers' 1>&2;  \
286             exit 1; } || :
287
288 sc_the_the:
289         @grep -ni '\<the ''the\>' $$($(CVS_LIST_EXCEPT)) &&             \
290           { echo '$(ME): found use of "the ''the";' 1>&2;               \
291             exit 1; } || :
292
293 sc_tight_scope:
294         $(MAKE) -C src $@
295
296 sc_trailing_blank:
297         @grep -n '[      ]$$' $$($(CVS_LIST_EXCEPT)) &&                 \
298           { echo '$(ME): found trailing blank(s)'                       \
299                 1>&2; exit 1; } || :
300
301 # Match lines like the following, but where there is only one space
302 # between the options and the description:
303 #   -D, --all-repeated[=delimit-method]  print all duplicate lines\n
304 longopt_re = --[a-z][0-9A-Za-z-]*(\[=[0-9A-Za-z-]*\])?
305 sc_two_space_separator_in_usage:
306         @grep -nE '^   *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$'         \
307             $$($(CVS_LIST_EXCEPT)) &&                                   \
308           { echo "$(ME): help2man requires at least two spaces between"; \
309             echo "$(ME): an option and its description"; \
310                 1>&2; exit 1; } || :
311
312 # Look for diagnostics that aren't marked for translation.
313 # This won't find any for which error's format string is on a separate line.
314 sc_unmarked_diagnostics:
315         @grep -nE                                                       \
316             '\<error \([^"]*"[^"]*[a-z]{3}' $$($(CVS_LIST_EXCEPT))      \
317           | grep -v '_''(' &&                                           \
318           { echo '$(ME): found unmarked diagnostic(s)' 1>&2;            \
319             exit 1; } || :
320
321 # Avoid useless parentheses like those in this example:
322 # #if defined (SYMBOL) || defined (SYM2)
323 sc_useless_cpp_parens:
324         @grep -n '^# *if .*defined *(' $$($(CVS_LIST_EXCEPT)) &&        \
325           { echo '$(ME): found useless parentheses in cpp directive'    \
326                 1>&2; exit 1; } || :
327
328 # Ensure that the c99-to-c89 patch applies cleanly.
329 patch-check:
330         rm -rf src-c89 $@.1 $@.2
331         cp -a src src-c89
332         (cd src-c89; patch -V never --fuzz=0) < src/c99-to-c89.diff \
333           > $@.1 2>&1
334         if test "$${REGEN_PATCH+set}" = set; then \
335           diff -upr src src-c89 > new-diff || : ; fi
336         grep -v '^patching file ' $@.1 > $@.2 || :
337         msg=ok; test -s $@.2 && msg='fuzzy patch' || : ;        \
338         rm -f src-c89/*.o || msg='rm failed';                   \
339         $(MAKE) -C src-c89 CFLAGS='-Wdeclaration-after-statement -Werror' \
340           || msg='compile failure with extra options';          \
341         rm -rf src-c89 $@.1 $@.2;                               \
342         test "$$msg" = ok && : || echo "$$msg" 1>&2;            \
343         test "$$msg" = ok
344
345 # Ensure that date's --help output stays in sync with the info
346 # documentation for GNU strftime.  The only exception is %N,
347 # which date accepts but GNU strftime does not.
348 extract_char = sed 's/^[^%][^%]*%\(.\).*/\1/'
349 strftime-check:
350         if test -f $(srcdir)/src/date.c; then                           \
351           grep '^  %.  ' $(srcdir)/src/date.c | sort                    \
352             | $(extract_char) > $@-src;                                 \
353           { echo N;                                                     \
354             info libc date calendar format | grep '^    `%.'\'          \
355               | $(extract_char); } | sort > $@-info;                    \
356           diff -u $@-src $@-info || exit 1;                             \
357           rm -f $@-src $@-info;                                         \
358         fi
359
360 check-AUTHORS:
361         $(MAKE) -C src $@
362
363 # Ensure that we use only the standard $(VAR) notation,
364 # not @...@ in Makefile.am, now that we can rely on automake
365 # to emit a definition for each substituted variable.
366 makefile-check:
367         grep -nE '@[A-Z_0-9]+@' `find . -name Makefile.am` \
368           && { echo 'Makefile.maint: use $$(...), not @...@' 1>&2; exit 1; } || :
369
370 news-date-check: NEWS
371         today=`date +%Y-%m-%d`; \
372         if head NEWS | grep '^\*.* $(VERSION_REGEXP) ('$$today')' \
373             >/dev/null; then \
374           :; \
375         else \
376           echo "version or today's date is not in NEWS" 1>&2; \
377           exit 1; \
378         fi
379
380 changelog-check:
381         if head ChangeLog | grep 'Version $(VERSION_REGEXP)\.$$' \
382             >/dev/null; then \
383           :; \
384         else \
385           echo "$(VERSION) not in ChangeLog" 1>&2; \
386           exit 1; \
387         fi
388
389 m4-check:
390         @grep -n 'AC_DEFUN([^[]' m4/*.m4 \
391           && { echo 'Makefile.maint: quote the first arg to AC_DEFUN' 1>&2; \
392                exit 1; } || :
393
394 # Verify that all source files using _() are listed in po/POTFILES.in.
395 # FIXME: don't hard-code file names below; use a more general mechanism.
396 po-check:
397         if test -f po/POTFILES.in; then                                 \
398           grep -E -v '^(#|$$)' po/POTFILES.in                           \
399             | grep -v '^src/false\.c$$' | sort > $@-1;                  \
400           files=;                                                       \
401           for file in $$($(CVS_LIST_EXCEPT)) lib/*.[ch]; do             \
402             case $$file in                                              \
403             djgpp/* | man/*) continue;;                                 \
404             esac;                                                       \
405             case $$file in                                              \
406             *.[ch])                                                     \
407               base=`expr " $$file" : ' \(.*\)\..'`;                     \
408               { test -f $$base.l || test -f $$base.y; } && continue;;   \
409             esac;                                                       \
410             files="$$files $$file";                                     \
411           done;                                                         \
412           grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files          \
413             | sort -u > $@-2;                                           \
414           diff -u $@-1 $@-2 || exit 1;                                  \
415           rm -f $@-1 $@-2;                                              \
416         fi
417
418 # In a definition of #define AUTHORS "... and ..." where the RHS contains
419 # the English word `and', the string must be marked with `N_ (...)' so that
420 # gettext recognizes it as a string requiring translation.
421 author_mark_check:
422         @grep -n '^# *define AUTHORS "[^"]* and ' src/*.c |grep -v ' N_ (' && \
423           { echo 'Makefile.maint: enclose the above strings in N_ (...)' 1>&2; \
424             exit 1; } || :
425
426 # Sometimes it is useful to change the PATH environment variable
427 # in Makefiles.  When doing so, it's better not to use the Unix-centric
428 # path separator of `:', but rather the automake-provided `@PATH_SEPARATOR@'.
429 # It'd be better to use `find -print0 ...|xargs -0 ...', but less portable,
430 # and there probably aren't many projects with so many Makefile.am files
431 # that we'd have to worry about limits on command line length.
432 msg = 'Makefile.maint: Do not use `:'\'' above; use @PATH_SEPARATOR@ instead'
433 makefile_path_separator_check:
434         @grep -n 'PATH=.*:' `find $(srcdir) -name Makefile.am` \
435           && { echo $(msg) 1>&2; exit 1; } || :
436
437 # Check that `make alpha' will not fail at the end of the process.
438 writable-files:
439         if test -d $(release_archive_dir); then :; else                 \
440           mkdir $(release_archive_dir);                                 \
441         fi
442         for file in $(distdir).tar.gz $(xd-delta)                       \
443                     $(release_archive_dir)/$(distdir).tar.gz            \
444                     $(release_archive_dir)/$(xd-delta); do              \
445           test -e $$file || continue;                                   \
446           test -w $$file                                                \
447             || { echo ERROR: $$file is not writable; fail=1; };         \
448         done;                                                           \
449         test "$$fail" && exit 1 || :
450
451 v_etc_file = lib/version-etc.c
452 sample-test = tests/sample-test
453 # Make sure that the copyright date in $(v_etc_file) is up to date.
454 copyright-check:
455         @if test -f $(v_etc_file); then \
456           grep 'enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' $(v_etc_file) \
457             >/dev/null \
458           || { echo 'out of date copyright in $(v_etc_file); update it' 1>&2; \
459                exit 1; }; \
460         fi
461         @if test -f $(sample-test); then \
462           grep '# Copyright (C) '$$(date +%Y)' Free' $(sample-test) \
463             >/dev/null \
464           || { echo 'out of date copyright in $(sample-test); update it' 1>&2; \
465                exit 1; }; \
466         fi
467
468
469 # Sanity checks with the repository.
470 # Abort early if this tag has already been used.
471 vc-tag-check:
472         used=no;                                                        \
473         if $(VC) --help | grep CVS; then                                        \
474           $(CVS) -n log -h README|grep -e $(this-vc-tag): >/dev/null    \
475             && used=yes;                                                \
476         else                                                            \
477           $(GIT) tag -l '^$(this-vc-tag)$$' && used=yes;                \
478         fi;                                                             \
479         if test "$$used" = yes; then                                    \
480           echo "$(this-vc-tag) has already been used; not tagging" 1>&2; \
481           exit 1;                                                       \
482         fi
483
484 vc-diff-check:
485         $(VC) diff > vc-diffs || :
486         if test -s vc-diffs; then                               \
487           cat vc-diffs;                                         \
488           echo "Some files are locally modified:" 1>&2;         \
489           exit 1;                                               \
490         else                                                    \
491           rm vc-diffs;                                          \
492         fi
493
494 cvs-check: vc-diff-check vc-tag-check
495
496 maintainer-distcheck:
497         $(MAKE) distcheck
498         $(MAKE) my-distcheck
499
500
501 # Tag before making distribution.  Also, don't make a distribution if
502 # checks fail.  Also, make sure the NEWS file is up-to-date.
503 # FIXME: use dist-hook/my-dist like distcheck-hook/my-distcheck.
504 vc-dist: $(local-check) cvs-check maintainer-distcheck
505         $(VC-tag) $(this-vc-tag)
506         $(MAKE) dist
507
508 # Use this to make sure we don't run these programs when building
509 # from a virgin tgz file, below.
510 null_AM_MAKEFLAGS = \
511   ACLOCAL=false \
512   AUTOCONF=false \
513   AUTOMAKE=false \
514   AUTOHEADER=false \
515   MAKEINFO=false
516
517 # Detect format-string/arg-list mismatches that would normally be obscured
518 # by the use of _().  The --disable-nls effectively defines away that macro,
519 # and building with CFLAGS='-Wformat -Werror' causes any format warning to be
520 # treated as a failure.  Also, check for shadowing problems with -Wshadow,
521 # and for pointer arithmetic problems with -Wpointer-arith.
522 # These CFLAGS are pretty strict.  If you build this target, you probably
523 # have to have a recent version of gcc and glibc headers.
524 TMPDIR ?= /tmp
525 t=$(TMPDIR)/$(PACKAGE)/test
526 my-distcheck: $(local-check) $(release_archive_dir)/$(prev-tgz)
527         -rm -rf $(t)
528         mkdir -p $(t)
529         GZIP=$(GZIP_ENV) $(AMTAR) -C $(t) -zxf $(distdir).tar.gz
530         cd $(t)/$(distdir)                              \
531           && ./configure --disable-nls                  \
532           && $(MAKE) CFLAGS='-Werror -Wall -Wformat -Wshadow -Wpointer-arith' \
533               AM_MAKEFLAGS='$(null_AM_MAKEFLAGS)'       \
534           && $(MAKE) dvi                                \
535           && $(MAKE) check                              \
536           && $(MAKE) distclean
537         (cd $(t) && mv $(distdir) $(distdir).old        \
538           && $(AMTAR) -zxf - ) < $(distdir).tar.gz
539         diff -ur $(t)/$(distdir).old $(t)/$(distdir)
540         cd $(t)/$(distdir)                              \
541           && (cd src && patch -V never --fuzz=0 <c99-to-c89.diff) \
542           && ./configure --disable-largefile            \
543                CFLAGS='-Werror -ansi -pedantic -Wno-long-long' \
544           && $(MAKE)
545         -rm -rf $(t)
546         @echo "========================"; \
547         echo "$(distdir).tar.gz is ready for distribution"; \
548         echo "========================"
549
550 WGET = wget
551 WGETFLAGS = -C off
552
553 rel-check:
554         tarz=/tmp/rel-check-tarz-$$$$; \
555         md5_tmp=/tmp/rel-check-md5-$$$$; \
556         set -e; \
557         trap 'status=$$?; rm -f $$tarz $$md5_tmp; exit $$status' 0 1 2 3 15; \
558         $(WGET) $(WGETFLAGS) -q --output-document=$$tarz $(url); \
559         echo "$(md5)  -" > $$md5_tmp; \
560         md5sum -c $$md5_tmp < $$tarz
561
562 prev-tgz = $(PACKAGE)-$(PREV_VERSION).tar.gz
563 xd-delta = $(PACKAGE)-$(PREV_VERSION)-$(VERSION).xdelta
564
565 rel-files = $(xd-delta) $(DIST_ARCHIVES)
566
567 # Approximate date of last "update" by the date on the ChangeLog file.
568 gnulib_snapshot_date = \
569   $$(date -u --date $$(stat --printf @%Y $(gnulib_dir)/ChangeLog) \
570      '+%Y-%m-%d %T %z')
571 announcement: NEWS ChangeLog $(rel-files)
572         @./build-aux/announce-gen                                       \
573             --release-type=$(RELEASE_TYPE)                              \
574             --package=$(PACKAGE)                                        \
575             --prev=$(PREV_VERSION)                                      \
576             --curr=$(VERSION)                                           \
577             --gpg-key-id=$(gpg_key_ID)                                  \
578             --news=NEWS                                                 \
579             --bootstrap-tools=autoconf,automake,bison,gnulib            \
580             --gnulib-snapshot-date=$(gnulib_snapshot_date)              \
581             $(addprefix --url-dir=, $(url_dir_list))
582
583 ## ---------------- ##
584 ## Updating files.  ##
585 ## ---------------- ##
586
587 ftp-gnu = ftp://ftp.gnu.org/gnu
588 www-gnu = http://www.gnu.org
589
590 # Use mv, if you don't have/want move-if-change.
591 move_if_change ?= move-if-change
592
593 emit_upload_commands:
594         @echo =====================================
595         @echo =====================================
596         @echo "$(srcdir)/build-aux/gnupload $(GNUPLOADFLAGS) \\"
597         @echo "    --to $(gnu_rel_host):coreutils \\"
598         @echo "  $(rel-files)"
599         @echo '# send the /tmp/announcement e-mail'
600         @echo =====================================
601         @echo =====================================
602
603 $(xd-delta): $(release_archive_dir)/$(prev-tgz) $(distdir).tar.gz
604         xdelta delta -9 $^ $@ || :
605
606 .PHONY: alpha beta major
607 alpha beta major: news-date-check changelog-check $(local-check)
608         test $@ = major                                         \
609           && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
610                || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
611           || :
612         $(MAKE) vc-dist
613         $(MAKE) $(xd-delta)
614         $(MAKE) -s announcement RELEASE_TYPE=$@ > /tmp/announce-$(my_distdir)
615         ln $(rel-files) $(release_archive_dir)
616         chmod a-w $(rel-files)
617         $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
618         echo $(VERSION) > $(prev_version_file)
619         $(VC) commit -m \
620           '$(prev_version_file): Record previous version: $(VERSION).' \
621           $(prev_version_file)